diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
new file mode 100644
index 000000000..e9574cef9
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
@@ -0,0 +1,533 @@
+package net.minecraft.client.gui;
+
+import com.codewaves.codehighlight.core.Highlighter;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.console.LogMessage;
+import net.minecraft.client.console.LogMessageReceiver;
+import net.minecraft.client.console.syntax.RendererFactory;
+import net.minecraft.client.gui.text.ITextField;
+import net.minecraft.client.gui.text.TextFieldEditor;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.console.shell.RuntimeExecutor;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.client.render.window.GameWindowGLFW;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.glfw.GLFW;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.GL11;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+public class ScreenConsole extends Screen {
+    private static final class LogRenderer extends Gui {
+        private static final int SCROLL_INDICATOR_WIDTH = 3;
+        private static final int SCROLL_INDICATOR_HEIGHT = 32;
+
+        private static final @NotNull List<@NotNull String> WORKED_LINES = new ArrayList<>();
+
+        private static boolean callbackInitialized = false;
+
+        private final @NotNull Map<LogMessage.@NotNull Level, @NotNull TextFormatting> preludes = new HashMap<>();
+
+        private @Nullable Font font = null;
+
+        private int width = 0;
+        private int scroll = 0;
+
+        public LogRenderer() {
+            this.preludes.put(LogMessage.Level.ERROR, TextFormatting.RED);
+            this.preludes.put(LogMessage.Level.WARN, TextFormatting.YELLOW);
+            this.preludes.put(LogMessage.Level.INFO, TextFormatting.WHITE);
+            this.preludes.put(LogMessage.Level.DEBUG, TextFormatting.LIGHT_BLUE);
+            this.preludes.put(LogMessage.Level.TRACE, TextFormatting.GRAY);
+        }
+
+        public void init(final @NotNull Minecraft mc, final int width) {
+            this.width = width;
+            this.font = new Font(mc, mc.gameSettings, mc.textureManager, true);
+
+            initWorkedLines();
+            final @NotNull List<@NotNull String> workedLine = new ArrayList<>();
+            if (!callbackInitialized) {
+                LogMessageReceiver.addCallback((message) -> {
+                    formatString(message, workedLine);
+                    WORKED_LINES.addAll(workedLine);
+                    trimWorkedLines();
+                });
+                callbackInitialized = true;
+            }
+        }
+
+        public void render(final int x, final int y, final int numLines) {
+            if (numLines >= WORKED_LINES.size() - this.scroll) {
+                this.scroll = 0;
+            }
+
+            final int lines = Math.min(heightLines, WORKED_LINES.size() - this.scroll);
+            for (int i = lines - 1; i >= 0; i--) {
+                final @NotNull String line = WORKED_LINES.get((WORKED_LINES.size() - 1) - (i + this.scroll));
+                if (this.font != null) {
+                    this.font.drawString(line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i, 0xFF_CF_CF_CF);
+                }
+            }
+            renderScrollIndicator(x, y, numLines);
+        }
+
+        public int getHeight(final int numLines) {
+            return LINE_HEIGHT * numLines;
+        }
+
+        public int getWidth() {
+            return this.width;
+        }
+
+        public void scroll(final int numLines) {
+            if (WORKED_LINES.size() <= heightLines) {
+                return;
+            }
+            this.scroll = MathHelper.clamp(this.scroll + numLines, 0, WORKED_LINES.size() - heightLines);
+        }
+
+        public void setScroll(final int scroll) {
+            this.scroll = MathHelper.clamp(scroll, 0, WORKED_LINES.size() - heightLines);
+        }
+
+        private void renderScrollIndicator(final int x, final int y, final int numLines) {
+            if (numLines * LINE_HEIGHT <= SCROLL_INDICATOR_HEIGHT) {
+                drawRect(x + this.width - SCROLL_INDICATOR_WIDTH, y, x + this.width, y + numLines * LINE_HEIGHT, 0xFF_FF_FF_FF);
+                return;
+            }
+
+            final float scrollPercentage = 1.0f - getScrollPercentage();
+            final int scrollRegionHeight = numLines * LINE_HEIGHT - SCROLL_INDICATOR_HEIGHT;
+            final int scrollY = (int) (scrollRegionHeight * scrollPercentage);
+            drawRect(x + this.width - SCROLL_INDICATOR_WIDTH, y + scrollY, x + this.width, y + scrollY + SCROLL_INDICATOR_HEIGHT, 0xFF_FF_FF_FF);
+        }
+
+        private float getScrollPercentage() {
+            if (WORKED_LINES.size() <= heightLines) {
+                return 0.0f;
+            }
+            return MathHelper.clamp((float) this.scroll / (WORKED_LINES.size() - heightLines), 0.0f, 1.0f);
+        }
+
+        private void initWorkedLines() {
+            WORKED_LINES.clear();
+            final @NotNull List<@NotNull String> formattedLine = new ArrayList<>();
+
+            for (final @NotNull LogMessage message : LogMessageReceiver.getQueue()) {
+                formatString(message, formattedLine);
+                WORKED_LINES.addAll(formattedLine);
+            }
+            trimWorkedLines();
+        }
+
+        private void trimWorkedLines() {
+            while (WORKED_LINES.size() > 1000) {
+                WORKED_LINES.remove(0);
+            }
+        }
+
+        private void formatString(final @NotNull LogMessage message, final @NotNull List<@NotNull String> out) {
+            if (this.font == null) {
+                return;
+            }
+
+            out.clear();
+            final @NotNull String @NotNull[] workedString = message.getMessage()
+                .replace("\r\n", "\n")
+                .replace("\t", "    ")
+                .split("\n");
+
+            @NotNull TextFormatting currentFormat = this.preludes.getOrDefault(message.getLevel(), TextFormatting.WHITE);
+
+            for (final @NotNull String line : workedString) {
+                @NotNull String trimmedLine = line;
+
+                @NotNull StringBuilder sb = new StringBuilder();
+                int lineWidth = 0;
+                @NotNull TextFormatting nextFormat = currentFormat;
+                for (int i = 0; i < trimmedLine.length(); i++) {
+                    final char c = trimmedLine.charAt(i);
+                    if (c == TextFormatting.SPECIAL_CHAR && (i + 1 < trimmedLine.length())) {
+                        final @Nullable TextFormatting newFormat = TextFormatting.fromChar(trimmedLine.charAt(i + 1));
+                        if (newFormat != null) {
+                            nextFormat = newFormat;
+                        }
+                        lineWidth -= this.font.getCharWidth(c) + this.font.getCharWidth(trimmedLine.charAt(i + 1));
+                    }
+                    final int cWidth = this.font.getCharWidth(c);
+                    if (lineWidth + cWidth >= this.width) {
+                        out.add(currentFormat.toString() + sb);
+                        sb = new StringBuilder();
+                        sb.append(nextFormat);
+                        lineWidth = 0;
+                    }
+                    sb.append(trimmedLine.charAt(i));
+                    lineWidth += cWidth;
+                }
+                out.add(currentFormat.toString() + sb);
+            }
+        }
+    }
+
+    private static final class InputRenderer extends Gui implements ITextField {
+        private static final @NotNull List<@NotNull String> HISTORY = new ArrayList<>();
+        private static final @Nullable RuntimeExecutor EXECUTOR = new RuntimeExecutor();
+
+        private @Nullable Font font = null;
+
+        private @NotNull String text = "";
+        private @NotNull String highlightedText = "";
+        private @NotNull String originalText = "";
+        private int cursorCounter = 0;
+        private final @NotNull TextFieldEditor editor;
+        private int historyIndex = 0;
+
+        private final Highlighter<String> highlighter = new Highlighter<>(new RendererFactory());
+
+        public InputRenderer() {
+            this.editor = new TextFieldEditor(this, true);
+        }
+
+        public void init(final @NotNull Minecraft mc) {
+            this.font = new Font(mc, mc.gameSettings, mc.textureManager, true);
+        }
+
+        public void tick() {
+            this.cursorCounter++;
+        }
+
+        public void render(final int x, final int y) {
+            if (this.font == null) return;
+
+            boolean addedStart = false;
+            final @NotNull String @NotNull[] splitHighlighted = this.highlightedText.split("\n", -1);
+            for (int i = 0; i < splitHighlighted.length; i++) {
+                drawStringNoShadow(this.font, (addedStart ? "  " : "> ") + splitHighlighted[i].replace("\n", ""), x, y + i * LINE_HEIGHT, 0xFF_E0_E0_E0);
+                addedStart = true;
+            }
+
+            final @NotNull String @NotNull [] split = this.text.split("\n", -1);
+            final int offsetWidth = this.font.getStringWidth("  ");
+            final int[] cursorPos = getCursor();
+            final int cursorX;
+            if (cursorPos[0] == split[cursorPos[1]].length()) {
+                cursorX = this.font.getStringWidth(split[cursorPos[1]]);
+            } else {
+                cursorX = this.font.getStringWidth(split[cursorPos[1]].substring(0, cursorPos[0]));
+            }
+            if ((cursorCounter / 6) % 2 == 0) {
+                drawStringNoShadow(this.font, "█", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_FF_FF_FF);
+                if (this.editor.getCursor() < this.text.length() && this.text.charAt(this.editor.getCursor()) != '\n') {
+                    drawStringNoShadow(this.font, "" + this.text.charAt(this.editor.getCursor()), x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_00_00_00);
+                }
+            } else {
+                drawStringNoShadow(this.font, "_", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_FF_FF_FF);
+            }
+        }
+
+        public void click(final int mx, final int my) {
+            if (this.font == null) return;
+
+            final int oneChar = this.font.getStringWidth(" ");
+
+            final int cx = (mx - (oneChar * 2)) / oneChar;
+            final int cy = my / LINE_HEIGHT;
+
+            final @NotNull String @NotNull[] split = this.text.split("\n");
+            int cursor = 0;
+            for (int y = 0; y < cy; y++) {
+                cursor += split[y].length() + 1;
+            }
+            cursor += MathHelper.clamp(cx, 0, split[cy].length());
+
+            this.editor.setCursor(cursor);
+        }
+
+        public void handleInput(final int key, final char character) {
+            final boolean isMultiLine = this.text.contains("\n");
+            if (key == Keyboard.KEY_TAB) {
+                for (int i = 0; i < 4; i++) {
+                    this.editor.handleInput(0, ' ');
+                }
+            } else if (key == Keyboard.KEY_RETURN) {
+                if (this.text.isEmpty()) {
+                    return;
+                }
+                if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) {
+                    this.editor.handleInput(key, '\n');
+                } else {
+                    final @NotNull String line = this.text.trim();
+                    final @NotNull String @NotNull[] split = this.highlightedText.trim().split("\n");
+                    final @NotNull StringBuilder sb = new StringBuilder();
+                    for (final @NotNull String s : split) {
+                        sb
+                            .append(TextFormatting.LIGHT_GRAY)
+                            .append("> ")
+                            .append(TextFormatting.WHITE)
+                            .append(s)
+                            .append("\n");
+                    }
+                    LogMessageReceiver.append(sb.toString());
+
+                    if (EXECUTOR != null) {
+                        final @NotNull String message = EXECUTOR.runCode(line);
+                        LogMessageReceiver.append(message);
+                    }
+                    HISTORY.add(line);
+                    this.historyIndex = 0;
+
+                    this.editor.setText("");
+                }
+            } else if (key == Keyboard.KEY_HOME && isMultiLine) {
+                final int[] cursorPos = getCursor();
+                int realPos = this.editor.getCursor();
+                realPos -= cursorPos[0];
+                this.editor.setCursor(realPos);
+            } else if (key == Keyboard.KEY_END && isMultiLine) {
+                final @NotNull String @NotNull[] split = this.text.split("\n", -1);
+                final int[] cursorPos = getCursor();
+                int realPos = this.editor.getCursor();
+                realPos -= cursorPos[0];
+                realPos += split[cursorPos[1]].length();
+                this.editor.setCursor(realPos);
+            } else if (key == Keyboard.KEY_UP) {
+                if (isMultiLine && !(Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT))) {
+                    final @NotNull String @NotNull[] split = this.text.split("\n", -1);
+                    int[] cursorPos = getCursor();
+                    if (cursorPos[1] == 0) return;
+                    int realPos = this.editor.getCursor();
+                    realPos -= cursorPos[0];
+                    cursorPos[1]--;
+                    realPos -= split[cursorPos[1]].length() + 1;
+                    cursorPos[0] = MathHelper.clamp(cursorPos[0], 0, split[cursorPos[1]].length());
+                    realPos += cursorPos[0];
+                    this.editor.setCursor(realPos);
+                } else if (!HISTORY.isEmpty()) {
+                    if (this.historyIndex == 0) {
+                        this.originalText = getText();
+                    }
+                    if (this.historyIndex < HISTORY.size()) {
+                        this.historyIndex++;
+                        setText(HISTORY.get(HISTORY.size() - this.historyIndex));
+                    }
+                    this.editor.setCursor(10000);
+                }
+            } else if (key == Keyboard.KEY_DOWN) {
+                if (isMultiLine && !(Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT))) {
+                    final @NotNull String @NotNull[] split = this.text.split("\n", -1);
+                    int[] cursorPos = getCursor();
+                    if (cursorPos[1] == split.length - 1) return;
+                    int realPos = this.editor.getCursor();
+                    realPos -= cursorPos[0];
+                    realPos += split[cursorPos[1]].length() + 1;
+                    cursorPos[1]++;
+                    cursorPos[0] = MathHelper.clamp(cursorPos[0], 0, split[cursorPos[1]].length());
+                    realPos += cursorPos[0];
+                    this.editor.setCursor(realPos);
+                } else if (this.historyIndex > 0) {
+                    if (this.historyIndex - 1 == 0) {
+                        this.historyIndex--;
+                        setText(this.originalText);
+                    } else {
+                        this.historyIndex--;
+                        setText(HISTORY.get(HISTORY.size() - this.historyIndex));
+                    }
+                    this.editor.setCursor(10000);
+                }
+            } else if (character != '`') {
+                this.editor.handleInput(key, character);
+            }
+        }
+
+        public int getHeightLines() {
+            int c = 1;
+            for (int i = 0; i < this.text.length(); i++) {
+                if (this.text.charAt(i) == '\n') {
+                    c++;
+                }
+            }
+            return c;
+        }
+
+        @Override
+        public void setText(final @NotNull String text) {
+            this.text = text;
+            this.highlightedText = this.highlighter.highlight("java", text).getResult();
+        }
+
+        @Override
+        public @NotNull String getText() {
+            return this.text;
+        }
+
+        @Override
+        public int maxLength() {
+            return 1024;
+        }
+
+        private int @NotNull[] getCursor() {
+            if (this.font == null) {
+                return new int[2];
+            }
+
+            final @NotNull String @NotNull[] split = this.text.split("\n", -1);
+
+            int cursor = this.editor.getCursor();
+            int cursorLine = 0;
+            for (int i = 0; i < split.length; i++) {
+                if (cursor - (split[i].length() + 1) < 0) {
+                    cursorLine = i;
+                    break;
+                }
+                cursor -= split[i].length() + 1;
+            }
+            return new int[] { cursor, cursorLine };
+        }
+    }
+
+    private static final int LINES_TO_SCROLL = 6;
+    private static final int PADDING = 4;
+    private static final int LINE_HEIGHT = 12;
+
+    private static int heightLines = 12;
+
+    private boolean dragging = false;
+
+    private final @NotNull LogRenderer logRenderer;
+    private final @NotNull InputRenderer inputRenderer;
+
+    public ScreenConsole(final @Nullable Screen parent) {
+        super(parent);
+
+        this.logRenderer = new LogRenderer();
+        this.inputRenderer = new InputRenderer();
+    }
+
+    private int getMaxY() {
+        return PADDING + (heightLines - this.inputRenderer.getHeightLines()) * LINE_HEIGHT + PADDING + PADDING + this.inputRenderer.getHeightLines() * LINE_HEIGHT + PADDING;
+    }
+
+    @Override
+    public void tick() {
+        super.tick();
+
+        this.inputRenderer.tick();
+    }
+
+    @Override
+    public void init() {
+        if (this.parentScreen != null) {
+            if (this.parentScreen.width != width || this.parentScreen.height != height)
+            {
+                this.parentScreen.width = width;
+                this.parentScreen.height = height;
+                this.parentScreen.buttons.clear();
+                this.parentScreen.init();
+            }
+        }
+
+        super.init();
+        Keyboard.enableRepeatEvents(true);
+
+        this.logRenderer.init(this.mc, this.width - PADDING * 2);
+        this.inputRenderer.init(this.mc);
+    }
+
+    @Override
+    public void removed() {
+        super.removed();
+        Keyboard.enableRepeatEvents(false);
+    }
+
+    @Override
+    public void render(int mx, int my, float partialTick) {
+        super.render(mx, my, partialTick);
+
+        if (this.parentScreen != null) {
+            this.parentScreen.render(-1, -1, partialTick);
+        }
+
+        final int dWheel = Mouse.getDWheel();
+        if (dWheel != 0) {
+            this.logRenderer.scroll(dWheel * LINES_TO_SCROLL);
+        }
+
+        if (this.dragging) {
+            heightLines = Math.max(1, ((my - (PADDING + PADDING + PADDING + PADDING - (LINE_HEIGHT / 2))) / LINE_HEIGHT));
+        }
+
+        if (getMaxY() >= this.height - 1) {
+            heightLines = Math.max(1, ((this.height - (PADDING + PADDING + PADDING + PADDING)) / LINE_HEIGHT) - 1);
+        }
+
+        GL11.glDisable(GL11.GL_TEXTURE_2D);
+        drawRect(0, 0, this.width, getMaxY(), 0xDF_00_00_00);
+
+        this.logRenderer.render(PADDING, PADDING, heightLines - inputRenderer.getHeightLines());
+
+        final int inputRendererHeight = this.inputRenderer.getHeightLines() * LINE_HEIGHT;
+        this.inputRenderer.render(PADDING, getMaxY() - PADDING - inputRendererHeight);
+
+        drawRect(PADDING, getMaxY() - (PADDING + inputRendererHeight + PADDING) - 2, this.width - PADDING, getMaxY() - (PADDING + inputRendererHeight + PADDING) - 1, 0x7F_9F_9F_9F);
+
+        if (mouseOverGrabbyRegion(mx, my) || this.dragging) {
+            setDesiredCursor(CursorShape.VERTICAL_RESIZE);
+        } else if (mx > PADDING && my >= getMaxY() - (PADDING + inputRendererHeight) && my < getMaxY() - PADDING) {
+            setDesiredCursor(CursorShape.I_BEAM);
+        } else {
+            setDesiredCursor(CursorShape.ARROW);
+        }
+
+        drawRect(0, getMaxY(), this.width, getMaxY() + 1, (mouseOverGrabbyRegion(mx, my) || this.dragging) ? 0xFF_DF_DF_DF : 0xFF_9F_9F_9F);
+    }
+
+    @Override
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (eventKey == this.mc.gameSettings.keyShowConsole.getKeyCode() || eventKey == Keyboard.KEY_ESCAPE) {
+            this.mc.displayScreen(this.parentScreen);
+        } else {
+            if (eventKey == Keyboard.KEY_RETURN) {
+                this.logRenderer.setScroll(0);
+            }
+            this.inputRenderer.handleInput(eventKey, eventCharacter);
+        }
+    }
+
+    @Override
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        super.mouseClicked(mx, my, buttonNum);
+
+        final int inputRendererHeight = this.inputRenderer.getHeightLines() * LINE_HEIGHT;
+
+        if (buttonNum == 0 && mouseOverGrabbyRegion(mx, my)) {
+            this.dragging = true;
+        } else if (buttonNum == 0 && mx >= PADDING && my >= getMaxY() - PADDING - inputRendererHeight && my <= getMaxY() - PADDING) {
+            this.inputRenderer.click(mx - PADDING, my - (getMaxY() - PADDING - inputRendererHeight));
+        } else if (my > getMaxY()) {
+            this.mc.displayScreen(this.parentScreen);
+        }
+    }
+
+    @Override
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        super.mouseReleased(mx, my, buttonNum);
+
+        if (buttonNum == 0) {
+            this.dragging = false;
+        }
+    }
+
+    private boolean mouseOverGrabbyRegion(final int mx, final int my) {
+        final int yMax = getMaxY();
+        return mx >= 0 && mx < this.width && my >= yMax - 1 && my <= yMax + 2;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
index 0f9288eff..49512a6ab 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
@@ -5,9 +5,9 @@ import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.controller.Button;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.input.controller.ControllerType;
-import net.minecraft.client.input.controller.Joystick;
 import net.minecraft.core.lang.I18n;
-import org.lwjgl.opengl.GL11;
+
+import java.util.Arrays;
 
 import java.util.Arrays;
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
index bfcafe858..8cab41988 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
@@ -216,7 +216,9 @@ public class ScreenCreateWorld extends Screen {
         drawString(font, stringtranslate.translateKey("gui.create_world.label.world_name"), width / 2 - 100, 47, 0xa0a0a0);
         drawString(font, stringtranslate.translateKey("gui.create_world.label.seed"), width / 2 - 100, 88, 0xa0a0a0);
         textboxWorldName.drawTextBox();
+        textboxWorldName.updateCursor(mc, mx, my);
         textboxSeed.drawTextBox();
+        textboxSeed.updateCursor(mc, mx, my);
         super.render(mx, my, partialTick);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
index 0c358845b..511d5a750 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudDesigner.java
@@ -111,6 +111,7 @@ public class ScreenHudDesigner
         boolean didSnap = false;
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
             if (component == heldComponent) continue;
+            if (!component.isEnabled(mc)) continue;
             Layout otherLayout = component.getLayout();
             boolean isNested = false;
             Layout nestedLayout = otherLayout;
@@ -292,6 +293,7 @@ public class ScreenHudDesigner
         }
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
             if (component == heldComponent) continue;
+            if (!component.isEnabled(mc)) continue;
             Layout layout = component.getLayout();
             component.renderPreview(mc, this, layout, width, height - BOTTOM_SPACE);
             if (heldComponent == null) {
@@ -377,6 +379,7 @@ public class ScreenHudDesigner
     private void updateComponentsUnderMouse(int mouseX, int mouseY) {
         componentsUnderMouse.clear();
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
+            if (!component.isEnabled(mc)) continue;
             Layout layout = component.getLayout();
             int cx = layout.getComponentX(mc, component, width);
             int cy = layout.getComponentY(mc, component, height - BOTTOM_SPACE);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
index 5f85f19fa..1a72d3bc1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
@@ -1,28 +1,27 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+import net.minecraft.client.gui.text.ITextField;
+import net.minecraft.client.gui.text.TextFieldEditor;
+import net.minecraft.client.input.InputType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.PacketSetItemName;
-import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
-public class ScreenLabelEditor extends Screen
+public class ScreenLabelEditor extends Screen implements ITextField
 {
-    private static final String allowedCharacters;
-
-    static
-    {
-        allowedCharacters = ChatAllowedCharacters.ALLOWED_CHARACTERS;
-    }
     protected String screenTitle;
     protected ItemStack item;
     protected String text;
+    protected TextFieldEditor editor;
     protected byte color;
     protected int xSize;
     protected int ySize;
     protected int slot;
+    protected int cursorCounter;
 
     public ScreenLabelEditor(final ItemStack item, int slot)
     {
@@ -33,12 +32,21 @@ public class ScreenLabelEditor extends Screen
         } else {
         	this.text = "";
         }
+        this.editor = new TextFieldEditor(this);
         this.color = item.getDisplayColor();
         xSize = 176;
         ySize = 166;
         this.slot = slot;
     }
 
+    @Override
+    public void tick() {
+        cursorCounter++;
+        if ((mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) && !(mc.currentScreen instanceof ScreenKeyboard)) {
+            buttonClicked(buttons.get(0)); // Close out of gui when exiting keyboard screen
+        }
+    }
+
     @Override
     protected void buttonClicked(final ButtonElement button)
     {
@@ -72,6 +80,16 @@ public class ScreenLabelEditor extends Screen
 
         drawStringCentered(font, TextFormatting.get(color) + "> " + text + " <", width / 2, 100, 0xffffff);
 
+        boolean drawCursor = !text.isEmpty() && (cursorCounter / 6) % 2 == 0;
+        if (drawCursor)
+        {
+            int width = font.getStringWidth(editor.getText());
+            if (editor.getCursor() < editor.getText().length())
+            {
+                width = font.getStringWidth(editor.getText().substring(0, editor.getCursor()));
+            }
+            drawString(font, "_", this.width / 2 - font.getStringWidth(editor.getText())/2 + width, 101, 0xffffff);
+        }
         super.render(mx, my, f);
     }
 
@@ -81,23 +99,24 @@ public class ScreenLabelEditor extends Screen
         buttons.clear();
         Keyboard.enableRepeatEvents(true);
         buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120, I18n.getInstance().translateKey("gui.edit_label.button.done")));
+
+        if (mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) {
+            mc.displayScreen(new ScreenKeyboard(this, editor,
+                (s) -> {},
+                (c, k, s) -> {},
+                s -> {}));
+        }
     }
 
     @Override
 	public void keyPressed(final char eventCharacter, final int eventKey, int mx, int my)
     {
-        if (eventKey == Keyboard.KEY_BACK && text.length() > 0)
-        {
-            text = text.substring(0, text.length() - 1);
-        }
-        if (allowedCharacters.indexOf(eventCharacter) >= 0 && text.length() < 15)
-        {
-            text += eventCharacter;
-        }
         if (eventKey == Keyboard.KEY_RETURN || eventKey == Keyboard.KEY_ESCAPE)
         {
             buttonClicked(buttons.get(0));
+            return;
         }
+        editor.handleInput(eventKey, eventCharacter);
     }
 
     @Override
@@ -106,4 +125,18 @@ public class ScreenLabelEditor extends Screen
         Keyboard.enableRepeatEvents(false);
     }
 
+    @Override
+    public void setText(String text) {
+        this.text = text;
+    }
+
+    @Override
+    public String getText() {
+        return text;
+    }
+
+    @Override
+    public int maxLength() {
+        return 16;
+    }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
index 2dbd276e9..0b7619178 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
@@ -512,6 +512,6 @@ public class ScreenPhotoMode extends Screen
 
     @Override
     public void guiSpecificControllerInput(ControllerInput controller) {
-
+        super.guiSpecificControllerInput(controller);
     }
 }
